/*
* Copyright (c) 2006, Matthijs Koot (matthijs at koot.biz)
* All rights reserved.
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*
*     * Redistributions of source code must retain the above copyright
*       notice, this list of conditions and the following disclaimer.
*     * Redistributions in binary form must reproduce the above copyright
*       notice, this list of conditions and the following disclaimer in the
*       documentation and/or other materials provided with the distribution.
*     * Neither the name of the Koot Organization nor the
*       names of its contributors may be used to endorse or promote products
*       derived from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND ANY
* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
* DISCLAIMED. IN NO EVENT SHALL THE REGENTS AND CONTRIBUTORS BE LIABLE FOR ANY
* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

===============================================================================

  MPCOS.H

  License     : BSD-style (yep, just sell it!)
  Author      : Matthijs Koot (matthijs at koot.biz)
  Description : This CChipknip class defines behavior for the Dutch 
                Proton-based payment card 'Chipknip'.

  History :
     2007-12-29, mrkoot: file created

  Remarks :
    - none

===============================================================================*/

#pragma once
#include "StdAfx.h"

#include "APDUScanner.h"
#include "APDUScannerDlg.h"
#include ".\mpcos.h"

class CMPCOS : public CSmartCard
{
public:

	CMPCOS(void);
	~CMPCOS(void);

	void CREATE_FILE(byte *pbResponseAPDU, DWORD dwExpectedResponseLn, BYTE bFileType, BYTE bNameLn, BYTE *pbName, BYTE *pbKey, bool bSuppressOutput);
	void SELECT_FILE(byte *pbResponseAPDU, DWORD dwExpectedResponseLn, byte bType, byte bFileID[2], bool bResponse, bool bSuppressOutput);
	void SELECT_FILE(byte *pbResponseAPDU, DWORD dwExpectedResponseLn, char* pcFileName, bool bResponse, bool bSuppressOutput);
	void SELECT_FILE_KEY(byte *pbResponseAPDU, DWORD dwExpectedResponseLn, BYTE bKn, BYTE bKf, byte *pbRandom, bool bSuppressOutput);
	void GET_RESPONSE(byte *pbResponseAPDU, DWORD dwExpectedResponseLn, BYTE bReadLn, bool bSuppressOutput);
	void READ_DATA(byte *pbResponseAPDU, DWORD dwExpectedResponseLn, byte bOffsetMSB, byte bOffsetLSB, byte bLcRecv, bool bSuppressOutput=false);
	void READ_RECORD(byte *pbResponseAPDU, DWORD dwExpectedResponseLn, byte bRecordNr, byte bRefControl, byte bLcRecv, bool bSuppressOutput=false);
	void UPDATE_BINARY(byte *pbResponseAPDU, DWORD dwExpectedResponseLn, byte bOffsetMSB, byte bOffsetLSB, byte bLcSend, byte *pbNewData, byte *pbKats, bool bSuppressOutput=false);
};
